//---------------------------------------------------------------------------
#include <vcl.h>
#include <shlobj.h>
#include <FileCtrl.hpp>
#pragma hdrstop

#include "thdir.h" 
#include "fcmain.h"
const SELDIRHELP = 1000;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BrowseFoldersDialog"
#pragma resource "*.dfm"
//Tfrm_fs *frm_fs;

//---------------------------------------------------------------------------
__fastcall Tfrm_fs::Tfrm_fs(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_fs::SpeedButtonSearchClick(TObject *Sender)
{
    if (!po_ThreadDir->ProcessRunning) {
        RichEditSearch->SetFocus ();
        RichEditSearch->Clear ();
        po_ThreadDir->SearchPath = EditSearch->Text;
        po_ThreadDir->SearchText = EditTextSearch->Text;
        po_ThreadDir->SearchSubDir = cb_subdir->Checked;
        po_ThreadDir->Resume ();
        }
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_fs::EditSearchKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch (Key) {
        case VK_RETURN:
            SpeedButtonSearchClick(Sender);
            break;
        }
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_fs::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch (Key) {
        case VK_ESCAPE:
            po_ThreadDir->StopProcess = true;
            break;
        }
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_fs::FormResize(TObject *Sender)
{
    EditSearch->Width = (PanelOptions->Left-EditSearch->Left) - 10;
    EditTextSearch->Width = (PanelOptions->Left-EditTextSearch->Left) - 10;
}
//---------------------------------------------------------------------------
int BrowseCallbackProc(HWND hwnd,
                      UINT uMsg,
                      LPARAM lParam,
                      LPARAM lpData
                     );

void __fastcall Tfrm_fs::SpeedButtonDirClick(TObject *Sender)
{
    BrowseFoldersDialog1->Folder = ExtractFilePath(EditSearch->Text);
    if (BrowseFoldersDialog1->Execute()) {
        if (BrowseFoldersDialog1->Folder.LastDelimiter("\\") == BrowseFoldersDialog1->Folder.Length()) {
            EditSearch->Text = BrowseFoldersDialog1->Folder + ExtractFileName (EditSearch->Text);
            }
        else {
            EditSearch->Text = BrowseFoldersDialog1->Folder + "\\" + ExtractFileName (EditSearch->Text);
            }
        }
}

//---------------------------------------------------------------------------

void __fastcall Tfrm_fs::FormClose(TObject *Sender, TCloseAction &Action)
{
    StatusBar1->SimpleText = "Terminating search window, please wait for thread to clean up";
    if (po_ThreadDir->ProcessRunning) {
        po_ThreadDir->StopProcess = true;
        po_ThreadDir->Kill = true;
        po_ThreadDir->Resume();
        po_ThreadDir->WaitFor ();
        po_ThreadDir->Terminate();
        }
    else {
        po_ThreadDir->Terminate();
        }
	Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_fs::FormCreate(TObject *Sender)
{
    po_ThreadDir = new ThreadDir (true);
}
//---------------------------------------------------------------------------


